#include "descriptor/descriptor.h"

int main(void) {

  ITEM	scena;
  /*elicottero*/
  ITEM elicottero;
  ITEM  surf_elicottero,surf_vetro,surf_pale;


  /*stanza*/
  ITEM	stanza;
  ITEM  surf_pareteA, surf_pareteB, surf_parete_porta, surf_parete_finestra, surf_soffitto, surf_pavimento;

/*wc*/
  ITEM	wc,mensola;
  ITEM  tavoletta, surf_tazza, cerchio_pulsante, pulsante, scarico,surf_wc;
/*elicottero*/
  ITEM  a,b,c,d,e,f,g,h,i,l,m,n,o,p,q,r,s,t,u,v,z,x,y,k,w;

  /*lavandino*/
  ITEM lavandino;
  ITEM pomello1,pomello2,poggia_pomello1,poggia_pomello2;
  ITEM tubo_lavandino,lavandino_sopra,lavandino_fuori,lavandino_sotto;

  /*lampada e specchio*/
  ITEM lampada,specchio;
  ITEM cornicie, surf_specchio,lampadina, porta_lampada, cerchio_porta_lampada;






  set_background(0.676,0.861,0.953,TRUE);
  set_ambient_light(1,1,1,0.7);
  create_point_light(4,0,-2,1,1,1,3.89,20, "light1");
  create_point_light(5.8,-18.5,7.9,1,1,1,4,20, "light2");
  create_point_light(5.8,-16.6,7.9,1,1,1,4,20, "light3");


  /*** ATTRIBUTI MATERIALI ***/

  ITEM attr_specchio;
   attr_specchio = create_attribute("attr_specchio");
	set_color(attr_specchio, 0.5,0.5,0.5, 0,0);
	set_reflectivity(attr_specchio, 1,500);





	  ITEM attr_muro_v;
	attr_muro_v = create_attribute("attr_muro_v");
	set_color(attr_muro_v, 0.224,0.376,0.302, 0.6,0.6);


	 ITEM attr_muro_b;

	attr_muro_b = create_attribute("attr_muro_b");
	set_color(attr_muro_b, 1,1,1, 0.5,0.5);



	ITEM attr_acqmar;
	attr_acqmar = create_attribute("attr_acqmar");
	set_color(attr_acqmar, 0.761,0.8,0.765, 0.4,0.4);
	set_reflectivity(attr_acqmar, 0.45,2);

	ITEM attr_plastica_b;
	attr_plastica_b = create_attribute("attr_plastica_b");
	set_color(attr_plastica_b, 1,1,1, 0.5,0.5);
	set_reflectivity(attr_plastica_b, 0.125,2);



	 ITEM attr_fuoco;

  attr_fuoco = create_attribute("attr_fuoco");
  set_color(attr_fuoco,1,0.38,0,0.5,0.5);
  set_reflectivity(attr_fuoco,0,0);
  set_transparency(attr_fuoco,0.87,0.68,10,0);

  ITEM attr_celeste;
  attr_celeste = create_attribute("attr_celeste");
  set_color(attr_celeste,0.68,0.86,1,0.5,0.5);
  set_reflectivity(attr_celeste,0,2);



  ITEM metallo;
  metallo = create_attribute("metallo");
  set_color(metallo,0.2,0.2,0.2,0.1,0.8);
  set_reflectivity(metallo,0.2,128);
  set_transparency(metallo,0,0,0,1.5);


  ITEM attr_rosso;
  attr_rosso = create_attribute("attr_rosso");
  set_color(attr_rosso,1,0,0,0.5,0.2);
  set_reflectivity(attr_rosso,0,2);
  set_transparency(attr_rosso,0,0,0,0);

  ITEM attr_giallo;

  attr_giallo = create_attribute("attr_giallo");
  set_color(attr_giallo,1,1,0.4,0.4,0.3);
  set_reflectivity(attr_giallo,0,128);
  set_transparency(attr_giallo,0,0,0,0);

  ITEM attr_grigio;
  attr_grigio = create_attribute("attr_grigio");
  set_color(attr_grigio,1,1,1,0.1,0.2);
  set_reflectivity(attr_grigio,0,2);
  set_transparency(attr_grigio,0,0,0,0);



  ITEM attr_metallic1;

  attr_metallic1 = create_attribute("attr_metallic1");
  set_color(attr_metallic1,1,0.7,0.2,0.2,0.8);
  set_reflectivity(attr_metallic1,0.17,15);
  set_transparency(attr_metallic1,0,0,0,1);



  ITEM attr_metallic2;
  attr_metallic2 = create_attribute("attr_metallic2");
  set_color(attr_metallic2,0.93,0.23,0.03,0.2,0.8);
  set_reflectivity(attr_metallic2,0.17,15);

  ITEM legno;
  legno = create_attribute("legno");
  set_color(legno,1,1,1,0.1,0.4);
  //set_reflectivity(legno,0.2,0);


  ITEM oro;
  oro = create_attribute("oro");
  set_color(oro,1,0.8,0,0.6,0.54);
  set_reflectivity(oro,0.1,1);




  /*carico le superfici del'elicottero*/

 surf_elicottero = read_obj("surf_elicottero.obj", "fusoliera_elicottero");
 surf_pale = read_obj("surf_eliche_rotore_elicottero.obj", "pale");
 surf_vetro = read_nurbs("surf_vetro_elicottero.db");

 /* set_attribute(surf_pale,metallo);
  set_attribute(surf_vetro,vetro);
  set_attribute(surf_elicottero,rame);

  elicottero = create_list(surf_pale, "elicottero");
  elicottero = insert_in_list(elicottero,surf_vetro);
  elicottero = insert_in_list(elicottero,surf_elicottero);*/

  /*carico le superfici della stanza*/
  surf_pareteA = read_nurbs("muro_1.db");
  set_domain_texture(surf_pareteA,attr_muro_b,"textures/mattonella_1.hr",0.0,0.1,0.0,0.1,TRUE,0.2,0.1);
  surf_pareteB = read_nurbs("muro_2.db");
  set_domain_texture(surf_pareteB,attr_muro_b,"textures/mattonella_1.hr",0.0,0.1,0.0,0.1,TRUE,0.2,0.1);
  surf_parete_porta = read_nurbs("muro_porta.dbe");
  set_domain_texture(surf_parete_porta,attr_muro_b,"textures/mattonella_1.hr",0.0,0.1,0.0,0.1,TRUE,0.2,0.1);
  surf_parete_finestra = read_nurbs("muro_finestra.dbe");
  set_domain_texture(surf_parete_finestra,attr_muro_b,"textures/mattonella_1.hr",0.0,0.1,0.0,0.1,TRUE,0.2,0.1);
  surf_soffitto = read_nurbs("soffitto.db");
  set_attribute(surf_soffitto,attr_muro_v);
  surf_pavimento = read_nurbs("pavimento.db");
  set_domain_texture(surf_pavimento,attr_muro_b,"textures/pav.hr",0.0,0.1,0.0,0.1,TRUE,0.2,0.1);

  stanza = create_list(surf_pareteB, "stanza");
  stanza = insert_in_list(stanza,surf_pareteA);
  stanza = insert_in_list(stanza,surf_parete_porta);
  stanza = insert_in_list(stanza,surf_parete_finestra);
  stanza = insert_in_list(stanza,surf_soffitto);
  stanza = insert_in_list(stanza,surf_pavimento);


  set_scale(stanza,10,10,10);

	/*carico le superfici wc*/
  surf_tazza = read_nurbs("surf_tazza.db");
  set_attribute(surf_tazza,attr_plastica_b);
/*set_attribute(surf_tazza,rame);
	set_scale(surf_tazza,10,10,10);*/

  cerchio_pulsante = read_nurbs("surf_cerchio_pulsante_wc.db");
  set_attribute(cerchio_pulsante,attr_metallic2);

  scarico = read_nurbs("surf_tubo_wc.db");
  set_attribute(scarico,attr_metallic2);

  pulsante = read_nurbs("surf_pulsante_wc.db");
  set_attribute(pulsante,attr_metallic2);

  tavoletta = read_nurbs("surf_tavoletta_wc.db");
  set_attribute(tavoletta,attr_plastica_b);



	//wc = read_obj("surf_wc.obj", "wc");
	wc = create_list(pulsante, "wc");
	wc = insert_in_list(wc,cerchio_pulsante);
	wc = insert_in_list(wc,scarico);
	wc = insert_in_list(wc,tavoletta);
	wc = insert_in_list(wc,surf_tazza);

	set_scale(wc,10,10,10);


	/*carico le superfici lavandino*/

//	lavandino = read_obj("surf_lavandino.obj", "lavandino");
	//wc = create_list(surf_wc, "wc");

	pomello1 = read_nurbs("surf_pomello_rubinetto_d.db");
	set_attribute(pomello1,attr_metallic1);

	pomello2 = read_nurbs("surf_pomello_rubinetto_s.db");
	set_attribute(pomello2,attr_metallic1);

	poggia_pomello1 = read_nurbs("surf_poggia_pomello_rubinetto_d.db");
	set_attribute(poggia_pomello1,attr_metallic1);

	poggia_pomello2 = read_nurbs("surf_poggia_pomello_rubinetto_s.db");
	set_attribute(poggia_pomello2,attr_metallic1);

	tubo_lavandino = read_nurbs("surf_tubo_rubinetto.db");
	set_attribute(tubo_lavandino,attr_metallic1);

	lavandino_sopra = read_nurbs("surf_lavandino_sopra.db");
	set_attribute(lavandino_sopra,attr_acqmar);

	lavandino_fuori = read_nurbs("surf_lavandino_sopra_fuori.db");
	set_attribute(lavandino_fuori,attr_acqmar);

	lavandino_sotto = read_nurbs("surf_lavandino_sotto.db");
	set_attribute(lavandino_sotto,attr_acqmar);

	lavandino = create_list(pomello1, "lavandino");
	lavandino = insert_in_list(lavandino,pomello2);
	lavandino = insert_in_list(lavandino,poggia_pomello1);
	lavandino = insert_in_list(lavandino,poggia_pomello2);
	lavandino = insert_in_list(lavandino,tubo_lavandino);
	lavandino = insert_in_list(lavandino,lavandino_sopra);
	lavandino = insert_in_list(lavandino,lavandino_fuori);
	lavandino = insert_in_list(lavandino,lavandino_sotto);


	set_scale(lavandino,10,10,10);

	/*carico le superfici specchio*/

	//specchio = read_obj("surf_specchio_lampada.obj", "specchio");
	//wc = create_list(surf_wc, "wc");


	cornicie = read_nurbs("surf_cornice_specchio.db");
	set_projection_texture(cornicie,legno,"textures/legnot.hr", 0,TRUE, 0.4,0.4);
	surf_specchio = read_nurbs("surf_specchio.db");
	set_attribute(surf_specchio,attr_specchio);


	cerchio_porta_lampada = read_nurbs("surf_cerchio_portalampada.db");
	set_attribute(cerchio_porta_lampada,attr_metallic1);
	porta_lampada = read_nurbs("surf_portalampada.db");
	set_attribute(cerchio_porta_lampada,attr_metallic1);
	lampadina = read_nurbs("surf_lampadina.db");
	set_attribute(lampadina,attr_fuoco);

	specchio = create_list(cornicie, "specchio");
	specchio = insert_in_list(specchio,surf_specchio);

	lampada = create_list(cerchio_porta_lampada, "lampada");
	lampada = insert_in_list(lampada,porta_lampada);
	lampada = insert_in_list(lampada,lampadina);



	set_scale(specchio,10,10,10);
	set_scale(lampada,10,10,10);

	/*carico le superfici mensola*/
	mensola = read_nurbs("surf_mensola.db");
	//set_domain_texture(mensola,legno,"textures/legnotexture.hr",0.0,1,0.0,1,FALSE,0.2,0.1);
	set_projection_texture(mensola,legno,"textures/legnot.hr", 0,TRUE, 0.4,0.4);
	set_scale(mensola,10,5,10);
	set_translate(mensola,0,-10,0);

	/*carico le superfici elicottero*/
 a = read_nurbs("surf_fusoliera_buco_vetro_elicottero.dbe");
 set_attribute(a,attr_celeste);

 b = read_nurbs("surf_vetro_elicottero.db");
 set_attribute(b,attr_specchio);

 c = read_nurbs("surf_ancoraggio_pale_elicottero.db");
 set_attribute(c,attr_grigio);

 d = read_nurbs("surf_rotore_elicottero.db");
 set_attribute(d,attr_grigio);

 e = read_nurbs("surf_piede_destro_elicottero.db");
 set_attribute(e,metallo);

 f = read_nurbs("surf_gamba1_destra_elicottero.db");
 set_attribute(f,metallo);

 g = read_nurbs("surf_gamba2_destra_elicottero.db");
 set_attribute(g,metallo);

 h = read_nurbs("surf_sferetta1_piede_destro_elicottero.db");
 set_attribute(h,oro);

 i = read_nurbs("surf_sferetta2_piede_destro_elicottero.db");
 set_attribute(i,oro);

 l = read_nurbs("surf_piede_elicottero.db");
 set_attribute(l,metallo);

 m = read_nurbs("surf_gamba2_elicottero.db");
 set_attribute(m,metallo);

 n = read_nurbs("surf_gamba1_elicottero.db");
 set_attribute(n,metallo);

 o = read_nurbs("surf_sferetta2_piede_elicottero.db");
 set_attribute(o,oro);

 p = read_nurbs("surf_sferetta1_piede_elicottero.db");
 set_attribute(p,oro);

 q = read_nurbs("surf_pala_elicottero.db");
 set_attribute(q,attr_grigio);

 r = read_nurbs("surf_pala1_elicottero.db");
 set_attribute(r,attr_grigio);

 s = read_nurbs("surf_pala2_elicottero.db");
 set_attribute(s,attr_grigio);

 t = read_nurbs("surf_pala3_elicottero.db");
 set_attribute(t,attr_grigio);

 u = read_nurbs("surf_coda_destra_elicottero.db");
 set_attribute(u,attr_rosso);

 v = read_nurbs("surf_coda_sinistra_elicottero.db");
 set_attribute(v,attr_rosso);

 z = read_nurbs("surf_coda_sotto_elicottero.db");
 set_attribute(z,attr_rosso);

 x = read_nurbs("surf_coda_dietro_elicottero.db");
 set_attribute(x,attr_rosso);

 y = read_nurbs("surf_coda_elicottero.db");
 set_attribute(y,attr_giallo);

 k = read_nurbs("surf_coda_sopra_elicottero.db");
 set_attribute(k,attr_giallo);

 w = read_nurbs("surf_coda_sopra_no_fine_elicottero.db");
 set_attribute(w,attr_rosso);



  elicottero=create_list(a, "elicottero");

  elicottero=insert_in_list(elicottero,c);
  elicottero=insert_in_list(elicottero,d);
  elicottero=insert_in_list(elicottero,e);
  elicottero=insert_in_list(elicottero,f);
  elicottero=insert_in_list(elicottero,g);
  elicottero=insert_in_list(elicottero,h);
  elicottero=insert_in_list(elicottero,i);
  elicottero=insert_in_list(elicottero,l);
  elicottero=insert_in_list(elicottero,m);
  elicottero=insert_in_list(elicottero,n);
  elicottero=insert_in_list(elicottero,o);
  elicottero=insert_in_list(elicottero,p);
  elicottero=insert_in_list(elicottero,u);
  elicottero=insert_in_list(elicottero,v);
  elicottero=insert_in_list(elicottero,z);
  elicottero=insert_in_list(elicottero,x);
  elicottero=insert_in_list(elicottero,y);
  elicottero=insert_in_list(elicottero,w);
  elicottero=insert_in_list(elicottero,k);

  elicottero=insert_in_list(elicottero,b);

  float xc=12;
  float yc=-7;
  float zc= -8.8;

  set_x_rotate(elicottero,90,1);
  set_z_rotate(elicottero,270,1);
  set_translate(elicottero,xc,yc,zc);

  surf_pale=create_list(q,"surf_pale");
  surf_pale=insert_in_list(surf_pale,r);
  surf_pale=insert_in_list(surf_pale,s);
  surf_pale=insert_in_list(surf_pale,t);


  set_x_rotate(surf_pale,90,1);
  set_z_rotate(surf_pale,250,1);
  set_translate(surf_pale,xc,yc,zc);

  /*creo la scena*/

	scena = create_list(stanza, "scena");
  scena = insert_in_list(scena,elicottero);
	scena = insert_in_list(scena,lavandino);
  scena = insert_in_list(scena,wc);
  scena = insert_in_list(scena,mensola);
  scena = insert_in_list(scena,specchio);
  scena = insert_in_list(scena,lampada);
  scena = insert_in_list(scena,surf_pale);

   float index;

   float costant = 0.0174532925;
   int frame=60;

   for (index=0; index<=frame; index++)
   {

	if(index<20){

		set_translate(surf_pale,-xc,-yc,0);
		set_z_rotate(surf_pale,-15,1);
		set_translate(surf_pale,xc,yc,0);
		set_translate(elicottero,0,0,0.5);
		set_translate(surf_pale,0,0,0.5);

	}else{
		xc=sin(270*costant)*0.5;
		yc=-cos(270*costant)*0.5;
		set_translate(elicottero,xc,yc,0);
		set_translate(surf_pale,xc,yc,0);
	}

	save_scene_ani(frame,"elicottero.ani","elicottero","scena_elicottero", scena);
   }

  
  return(0);
}



